'****************************************************************************
'*                 GPIOctl V1.0   2024 Darmok                               *
'*        ⮢ ணࠬ  ࠢ GPIO board V1.0                *
'*                 Microsoft Basic PDS7.1 (C)                               *
'*                                                                          *
'*    ᠭ 室  室 祭 楤,  ⠪ ᭥      *
'*  ᬮ   ᮮ⢥ 楤.                               *
'*                                                                          *
'*    ᫨ GPIO board ࠢ ᪮쪨 ன⢠  ᯮ     *
'*  ᪮쪮 ࠢ ணࠬ,  ।   ணࠬ *
'*    ᮢ ᫥ ࣠ ᠬ⥫쭮.              *
'*                                                                          *
'*  ਬ砭: 1. ᨨ 8250 UART  騬 Scratch Pad Register    *
'*              ணࠬ  ন.                               *
'*              2.  ᯮ짮 ணࠬ  । Windows ᫥      *
'*              ⪫ ᮮ⢥騩 COM   ᢮⢠ ⥬.      *
'****************************************************************************

DECLARE SUB PortInit ()
DECLARE SUB PutOuts (outs() AS INTEGER)
DECLARE SUB GetOuts (outs() AS INTEGER)
DECLARE SUB GetIns (ins() AS INTEGER)
DECLARE SUB GetAux (bits() AS INTEGER)
DECLARE SUB PutAux (bits() AS INTEGER)
DECLARE FUNCTION GetTRG% ()

DIM SHARED Port AS INTEGER            '室   楤
DIM SHARED TRGmode AS INTEGER         '室  㭪樨 GetTRG


'****************************************************************************
'-------- 易⥫쭮 믮塞   ᪥ ணࠬ. ---------------
'* 믮塞 ஢    GPIO board   室
'  樠㥬 .
   '* 砥  .
      'Port = &H3F8      'COM1 port adress
      Port = &H2F8      'COM2 port adress
      ' Port = &H3E8      'COM3 port adress
      'Port = &H2E8      'COM4 port adress
   '*
   PortInit
'*
'------------- 樠㥬 ᭮ ६ ---------------------------
'* OUT 室: outs(#) <-> OUT#   ( SUB PutOuts, SUB GetOuts )
   DIM outs(1 TO 8) AS INTEGER    ' ᯮ짮  
   '* ᢠ ᥬ outs(#) 祭 " ".  쭥襬
   '  㫨㥬 ⮫쪮 祭ﬨ 㦭 室.
      FOR outnum% = 1 TO 8: outs(outnum%) = 1: NEXT
   '*
'*
'* IN 室: IN# -> ins(#)        ( SUB GetIns )
   DIM ins(1 TO 4) AS INTEGER     ' ᯮ짮  
'*
'* TRG 室: TRG -> GetTRG        ( FUNCTION GetTRG )
   '* 砥 ० 室 TRG  ᮮ⢥⢨  ⠭
   '   J1  GPIO board:
   '  J1=OFF - ਣ ०,       TRGmode=-1;
   '  J1=ON  - ।⢥ ०, TRGmode= 0.
      TRGmode = 0
   '*
'*
'------------ 樠㥬 ᯮ⥫ ६ ---------------------
'* ᯮ⥫ : bits(#)<->BIT#  ( SUB PutAux, SUB GetAUX)
'  ᯮ⥫   뢠 ⢨  GPIO board, 
'  ।祭  ࠭ - 祭  맮
'  ணࠬ.
   DIM bits(1 TO 5) AS INTEGER            ' ᯮ짮  
   '* ᢠ ᥬ bits(#) 祭 " ".  쭥襬
   '  㫨㥬 ⮫쪮 祭ﬨ 㦭 ⮢.
      FOR bitnum% = 1 TO 5: bits(bitnum%) = 1: NEXT
   '*
'*
'****************************************************************************

'*    ࠢ饩 ணࠬ.
'  ...
'  GetIns ins()
'  ...
'  PutOuts outs()
'  ...
'  GetOuts outs()
'  ...
'  trg% = GetTRG%
'  ...
'  PutAux bits()
'  ...
'  GetAux bits()
'  ...
'*

END

SUB GetAux (bits() AS INTEGER)

'*****   楤 頥 祭 ⮢ ࠭   OUT1
'*****   ॣ MCR    RDAI, THREI, RLSI, MSI ॣ IER.
'*****   室 祭 .
'*****   頥 祭:
'*****     ᫨ ᮮ⢥騩  = 1,  bits(#) = -1;
'*****     ᫨ ᮮ⢥騩  = 0,  bits(#) = 0.
'*****   ॡ   ६ Port.

'* 室  ⮢.
   aIER% = Port + 1            'Interrupt Enable Register
   aMCR% = Port + 4            'Modem Control Register
'*
'* 뢠 ﭨ ॣ஢ IER  MCR.
   dIER% = INP(aIER%)
   dMCR% = INP(aMCR%)
'*
'* 室 祭   MCR  ᨬ   bits(1).
   IF (dMCR% AND 4) = 0 THEN bits(1) = 0 ELSE bits(1) = -1    '  OUT1
'*
'* 室 祭 ⮢  IER  ᨬ   bits(#)
   IF (dIER% AND 1) = 0 THEN bits(2) = 0 ELSE bits(2) = -1    '  RDAI
   IF (dIER% AND 2) = 0 THEN bits(3) = 0 ELSE bits(3) = -1    '  THREI
   IF (dIER% AND 4) = 0 THEN bits(4) = 0 ELSE bits(4) = -1    '  RLSI
   IF (dIER% AND 8) = 0 THEN bits(5) = 0 ELSE bits(5) = -1    '  MSI
'*

END SUB

SUB GetIns (ins() AS INTEGER)

'*****   楤 頥 祭 ⥪ ﭨ 室.
'*****   室 祭 .
'*****   頥 祭:
'*****     ᫨ IN#=HIGH,  ins(#)=-1;
'*****     ᫨ IN#=LOW,  ins(#)=0.
'*****   ॡ   ६ Port.

'* 室  .
   aMSR% = Port + 6          'Modem Status Register
'*
'* 뢠 ﭨ 室  ॣ MSR.
   dMSR% = INP(aMSR%)
'*
'* 室 ᮮ⢥騥   ᨬ  祭  ins(#).
   IF (dMSR% AND 128) = 0 THEN ins(1) = 0 ELSE ins(1) = -1    'DCD bit, IN1
   IF (dMSR% AND 32) = 0 THEN ins(2) = 0 ELSE ins(2) = -1     'DSR bit, IN2
   IF (dMSR% AND 16) = 0 THEN ins(3) = 0 ELSE ins(3) = -1     'CTS bit, IN3
   IF (dMSR% AND 64) = 0 THEN ins(4) = 0 ELSE ins(4) = -1     'RI bit,  IN4
'*

END SUB

SUB GetOuts (outs() AS INTEGER)

'*****   楤 頥  祭 ﭨ 室,
'*****   ࠭  ॣ SCR.
'*****   室 祭 .
'*****   頥 祭:
'*****     ᫨ OUT#=HIGH,  outs(#)=-1;
'*****     ᫨ OUT#=LOW,  outs(#)=0.
'*****   ॡ   ६ Port.

'* 室  .
   aSCR% = Port + 7             'Scratch Pad Register
'*
'* 뢠 ࠭ ﭨ 室  ॣ SCR.
   dSCR% = INP(aSCR%)
'*
'* 室 ᮮ⢥騥   ᨬ  祭  outs(#).
   IF (dSCR% AND 1) = 0 THEN outs(1) = 0 ELSE outs(1) = -1      'OUT1
   IF (dSCR% AND 2) = 0 THEN outs(2) = 0 ELSE outs(2) = -1      'OUT2
   IF (dSCR% AND 4) = 0 THEN outs(3) = 0 ELSE outs(3) = -1      'OUT3
   IF (dSCR% AND 8) = 0 THEN outs(4) = 0 ELSE outs(4) = -1      'OUT4
   IF (dSCR% AND 16) = 0 THEN outs(5) = 0 ELSE outs(5) = -1     'OUT5
   IF (dSCR% AND 32) = 0 THEN outs(6) = 0 ELSE outs(6) = -1     'OUT6
   IF (dSCR% AND 64) = 0 THEN outs(7) = 0 ELSE outs(7) = -1     'OUT7
   IF (dSCR% AND 128) = 0 THEN outs(8) = 0 ELSE outs(8) = -1    'OUT8
'*

END SUB

FUNCTION GetTRG%

'*****   㭪 頥 祭 ﭨ ਣ  ⥪饥
'*****   ﭨ 室 TRG.
'*****   室 祭 .
'*****   頥 祭:
'*****   1. ਣ ०, TRGmode=-1, J1=OFF.
'*****      ᫨   ।饣 뢠  室 TRG  
'*****       ᪮쪮 ᮢ ஢ HIGH  ⥫쭮  61
'*****      ᥪ㭤 (㧠  ᠬ   4.4 ᥪ㭤),
'*****       GetTRG=-1;
'*****      ᫨   ।饣 뢠 ᮢ  뫮
'*****        뫨  61 ᥪ㭤,  GetTRG=0.
'*****   2. ।⢥ ०, TRGmode=0, J1=ON.
'*****      ᫨   뢠  室 TRG  ஢ LOW,
'*****       GetTRG=0;
'*****      ᫨   뢠  室 TRG  ஢ HIGH,
'*****       GetTRG=-1.
'*****   ॡ   ६ Port  TRGmode.
'*****   ਬ砭: 室 TRG ᫥ ᯮ짮   ਣ, 
'*****    ।⢥.  ⠭ ⭮  
'*****    J1  GPIO board  ணࠬ   ६ TRGmode.

'* 室  ⮢.
   aLSR% = Port + 5                    'Line Status Register
   aMCR% = Port + 4                    'Modem Control Register
'*
'* 室 ﭨ ਣ  ⥪饥 ﭨ 室.
   SELECT CASE TRGmode
     CASE -1                           '室 ﭨ ਣ
       IF (INP(aLSR%) AND 16) = 0 THEN
         GetTRG% = 0                   ' BI=0,   뫮
       ELSE
         GetTRG% = -1                  ' BI=1,  
       END IF
     CASE 0                            '室 ⥪饥 ﭨ 室
       dLSR% = INP(aLSR%)              '뢠  BI
       '* ࣠ 室 TRG.
          dMCR% = INP(aMCR%)           '뢠 ॣ MCR
          OUT aMCR%, dMCR% AND 254     ' DTR=0 -> DTR=LOW
          '*  1 mS
             t# = TIMER + .001
             WHILE TIMER < t#: WEND
          '*
          OUT aMCR%, dMCR% OR 1        ' DTR=1 -> DTR=HIGH
          '*  1 mS
             t# = TIMER + .001
             WHILE TIMER < t#: WEND
          '*
       '*
       '* 뢠 ⥪饥 ﭨ 室 TRG.
          IF (INP(aLSR%) AND 16) = 0 THEN
            GetTRG% = 0                '᫨  BI=0,  RXD=LOW
          ELSE
            GetTRG% = -1               '᫨  BI=1,  RXD=HIGH
          END IF
       '*
   END SELECT
'*

END FUNCTION

SUB PortInit

'*****   ஢ઠ  ﭨ ⭮  GPIO board
'*****   (஢ LOW  室 "R" 74164  74273)  樠
'*****     ⮬ 砥.
'*****   頥 祭 .
'*****   室 祭 .
'*****   ॡ   ६ Port.
'*****   ਬ砭:  PC ⠭  OUT2 ॣ MCR  1 ⭮
'*****   ࠧ蠥 뤠 ᮢ  뢠  COM . ⮬
'*****   塞 ,  뢠.

'* 室  ⮢.
   aDLL% = Port                'Divisor Latch LSB
   aDLM% = Port + 1            'Divisor Latch MSB
   aIER% = Port + 1            'Interrupt Enable Register
   aLCR% = Port + 3            'Line Control Register
   aMCR% = Port + 4            'Modem Control Register
   aLSR% = Port + 5            'Line Status Register
   aSCR% = Port + 7            'Scratch Pad Register
'*
'* ஢塞 稥 ﭨ ⭮ .
   IF (INP(aLCR%) AND 64) = 64 THEN   'bit BC=1,  , TXD=HIGH
     EXIT SUB
   ELSE                               'bit BC=0,  , TXD=LOW
     '* 樠㥬 .
        '* 뢠 㫨  ॣ SCR.
        '  ਢ  ᮮ⢥⢨  ﭨ 室 OUT#=LOW.
           OUT aSCR%, 0
        '*
        '* ⠭  DTR  塞 㣨   ॣ MCR.
        '  塞 ᯮ⥫  #1, OUT2=0 -> 頥 뢠.
           OUT aMCR%, 1               'bit DTR=1 -> DTR=HIGH
        '*
        '* ⠭ প ࠡ뢠 RXD=HIGH.
           dLCR% = 128                'set format=1s,5,n,1 -> total 7 bits
           OUT aLCR%, dLCR%           ' DLAB=1
           dDLL% = 1: dDLM% = 0       'set 115200 boud, delay=0.061mS
           OUT aDLL%, dDLL%: OUT aDLM%, dDLM%
        '*
        '* 뢠 㫨  ॣ IER.
        '  塞 ᯮ⥫  #2,#3,#4  #5.
           dLCR% = 0: OUT aLCR%, dLCR%     ' DLAB=0
           dIER% = 0: OUT aIER%, dIER%
        '*
        '* 뢠  BI ( ਣ  室 TRG).
           dLSR% = INP(aLSR%)
        '*
     '*
     '*   reset.
        '* ⠭ WR(TXD)=HIGH.
           dLCR% = 64: OUT aLCR%, dLCR%    ' BC=1 -> TXD=HIGH
        '*
        '*  5 mS   LOW  室 "R" 74164  74273.
           t# = TIMER + .005
           WHILE TIMER < t#: WEND
        '*
     '*
   END IF
'*

END SUB

SUB PutAux (bits() AS INTEGER)

'*****   楤 ࠭ 祭 bits(1)   OUT1 ॣ MCR
'*****    祭 bits(2)...bits(5)   RDAI, THREI, RLSI, MSI
'*****   ॣ IER. 뢠 饭.
'*****   頥 祭 .
'*****   室 祭:
'*****     ᫨ bits(#)=-1,   ᮮ⢥饬  ࠭ 1;
'*****     ᫨ bits(#)= 0,   ᮮ⢥饬  ࠭ 0;
'*****     ᫨ bits(#)=  㣮 ᫮,  ࠭ 祭
'*****      .
'*****   ॡ   ६ Port.

'* 室  ⮢.
   aIER% = Port + 1            'Interrupt Enable Register
   aMCR% = Port + 4            'Modem Control Register
'*
'* 뢠 ﭨ ॣ஢ IER  MCR.
   dIER% = INP(aIER%)
   dMCR% = INP(aMCR%)
'*
'* ࠭塞 祭 bits(1)   OUT1 ॣ MCR.
   SELECT CASE bits(1)
     CASE -1
       dMCR% = dMCR% OR 4
       OUT aMCR%, dMCR%
     CASE 0
       dMCR% = dMCR% AND 251
       OUT aMCR%, dMCR%
   END SELECT
'*
'* ࠭塞 祭 bits(2)...bits(5)  
'  RDAI, THREI, RLSI, MSI ॣ IER.
   bitnum% = 1
   FOR auxbit% = 2 TO 5
     SELECT CASE bits(auxbit%)
       CASE -1
         dIER% = dIER% OR bitnum%
       CASE 0
         dIER% = dIER% AND (255 - bitnum%)
     END SELECT
     bitnum% = bitnum% * 2
   NEXT
   OUT aIER%, dIER%
'*

END SUB

SUB PutOuts (outs() AS INTEGER)

'*****   楤   室 ॣ 74273  ﭨ
'*****   室     ॣ SCR.
'*****   頥 祭 .
'*****   室 祭:
'*****     ᫨ outs(#) =-1,  OUT#=HIGH;
'*****     ᫨ outs(#) = 0,  OUT#=LOW;
'*****     ᫨ outs(#) =  㣮 ᫮,  ﭨ OUT#
'*****      .
'*****   ॡ   ६ Port.

'* 室  ⮢.
   aLCR% = Port + 3            'Line Control Register
   aMCR% = Port + 4            'Modem Control Register
   aSCR% = Port + 7            'Scratch Pad Register
'*
'* ।塞 冷   ﭨ 室  74164,
'  ᮣ᭮ ᪮ 奬 GPIO board.
   DIM ord(1 TO 8) AS INTEGER
   ord(1) = 1: ord(2) = 2: ord(3) = 3: ord(4) = 4
   ord(5) = 8: ord(6) = 7: ord(7) = 6: ord(8) = 5
'*
'* ᢠ 砫쭮 祭  ﭨ 室.
   newouts% = 0
'*
'* 뢠 ﭨ ॣ஢ MCR  SCR.
   dMCR% = INP(aMCR%)
   oldouts% = INP(aSCR%)
'*
'* ᫥⥫쭠   ﭨ 室  74164.
   FOR outnum% = 1 TO 8
     '* 室 祭   .
        '* 室 樮  .
           bitcd% = 1
           FOR order% = 1 TO ord(outnum%) - 1
             bitcd% = bitcd% * 2
           NEXT
        '*
        SELECT CASE outs(ord(outnum%))
          CASE 0
            outbit% = 0
          CASE -1
            outbit% = 1
          CASE ELSE
            IF (oldouts% AND bitcd%) = 0 THEN
              outbit% = 0
            ELSE
              outbit% = 1
            END IF
        END SELECT
     '*
     '* 뢠   74164  ᨬ 祭   newouts%.
        IF outbit% = 1 THEN
          newouts% = newouts% OR bitcd%
          dMCR% = dMCR% OR 2               ' RTS=1 -> RTS=HIGH
        ELSE
          dMCR% = dMCR% AND 253            ' RTS=0 -> RTS=LOW
        END IF
        OUT aMCR%, dMCR% AND 254           ' DTR=0 -> DTR=LOW
        OUT aMCR%, dMCR% OR 1              ' DTR=1 -> DTR=HIGH
     '*
   NEXT
'*
'* ࠭塞  ﭨ 室  ॣ SCR.
   OUT aSCR%, newouts%
'*
'* ९뢠  ﭨ 室  74164  74273.
   OUT aLCR%, 0                  ' BC=0 -> TXD=LOW
   OUT aLCR%, 64                 ' BC=1 -> TXD=HIGH
'*

END SUB

